/*
	Yet another fortune cookie type program.  I wrote this because
	I wanted one that didn't need a pointer file, didn't require
	ANSI.SYS loaded, didn't write files to disk and didn't crash
	'386 machines, and I couldn't find one.  The data file should
	be a standard text file with each fortune starting with a #
	character.  The fortunes have been collected from a variety of
	sources.

	Peter Summers - 24/3/91

    Minor changes by Richard Hieber (DL8MFQ), Dez. 92:
    - cprintf() replaced by printf();
    - textcolor() removed;
    - consideration of argc >= 1 removed to be compatible to calling
      format of certain PR programs;
    - original datafile skimmed for entries that suit my personal taste
      :-)

    The executable and datafile can be renamed, but should always have
    the same name, the datafile ending with ".DAT", and should reside in
    the same subdirectory.

*/

#include <conio.h>
#include <io.h>
#include <string.h>
#include <stdlib.h>
#include <values.h>
#include <time.h>
#include <fcntl.h>
#include <stat.h>

main (int argc, char *argv[])
  {
  int	handle,numread;
  long	offset;
  char	*extension,*datafile,*buffer,*outstring;

  datafile=calloc(128,sizeof(char));
  strcpy(datafile,argv[0]);
  extension=strrchr(datafile,'.');
  strcpy(extension,".DAT");
  buffer=calloc(4097,sizeof(char));

  handle=open(datafile,O_RDONLY|O_BINARY,S_IREAD);

  if (handle==-1)
    {
    printf("Can't open data file %s",datafile);
    exit(1);
    }

  randomize();
  offset=((long)random(MAXINT)*MAXINT+random(MAXINT))%filelength(handle);

  lseek(handle,offset,SEEK_SET);
  numread=read(handle,buffer,4096);

  if (numread==-1)
    {
    printf("Can't read from data file %s",datafile);
    exit(1);
    }

  if (numread<4096)
    {
    lseek(handle,0,SEEK_SET);
    read(handle,&buffer[numread],4096-numread);
    }

  outstring=strchr(buffer,'#')+1;

  *strchr(outstring,'#')=0;

  printf("%s",outstring);
  }
